local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
function BaypassFX (i_track, point_start, point_end)
  countFX = reaper.TrackFX_GetCount(i_track)
  for i=1, countFX do
    local FXParamCount = reaper.TrackFX_GetNumParams(i_track, i-1)
    local fx_env = reaper.GetFXEnvelope(i_track, i-1, FXParamCount-2, false)
    if fx_env == nil then
      fx_env = reaper.GetFXEnvelope(i_track, i-1, FXParamCount-2, true)
      reaper.InsertEnvelopePoint(fx_env, 0, 1, 1, 0, 0, false)
      reaper.InsertEnvelopePoint(fx_env, point_start, 0, 1, 0, 0, false)
      reaper.InsertEnvelopePoint(fx_env, point_end, 1, 1, 0, 0, false)
      local br_env = reaper.BR_EnvAlloc(fx_env, false )
      local active, visible, armed, inLane, laneHeight, defaultShape, minValue, maxValue, centerValue, type, faderScaling, automationItemsOptions = reaper.BR_EnvGetProperties(br_env)
      reaper.BR_EnvSetProperties(br_env, active, false, armed, inLane, laneHeight, defaultShape, faderScaling)
      reaper.BR_EnvFree(br_env, true)
    end
  end
end

------------------------------------------------------------------------------------------
function StartMastering()
  local counttracks = reaper.CountTracks(0)
  local startcurpos = reaper.GetCursorPosition()
  local CountAllMarkers = ({reaper.CountProjectMarkers(0)})[2]+({reaper.CountProjectMarkers(0)})[3]
  local CountMarkers = ({reaper.CountProjectMarkers(0)})[2]
  if CountMarkers == 0 then return end
  if counttracks == 1 then
    for i=1, CountAllMarkers do
      local curpos = reaper.GetCursorPosition()
      local RegionMarkers = ({reaper.EnumProjectMarkers(i-1)})[2]

      if RegionMarkers == false then
        local markerTime = ({reaper.EnumProjectMarkers(i-1)})[3]
        reaper.MoveEditCursor((markerTime - curpos), false)
        reaper.Main_OnCommand(40759,0) -- Item: Split items at edit cursor (select right)
        reaper.Main_OnCommand(40699,0) -- Edit: Cut items
        reaper.Main_OnCommand(41147,0) -- Track: Insert new track at end of mixer
        reaper.Main_OnCommand(42398,0) -- Item: Paste items/tracks
      end
    end
  end

  for i = 1, counttracks do
    local track = reaper.GetTrack(0, i-1)
    local _, name = reaper.GetTrackName(track)
    local item = reaper.GetTrackMediaItem(track, 0)

    if item then
      local item_start = reaper.GetMediaItemInfo_Value(item, "D_POSITION")
      local item_end = item_start + reaper.GetMediaItemInfo_Value(item, "D_LENGTH")
      -- reaper.AddProjectMarker(0, true, item_start, item_end, name, 1)
      BaypassFX (track, item_start, item_end)
    end
  end

  reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
end

StartMastering()
